:CS
* * * * * * * * * * * * * * * * * * * * * * * * * * *

POW USER'S MANUAL       for        CP/MUG Version 2.0

This manual was revised  (Feb, 1982) to be consistent
with the new  version of POW.   Some of this material
was adapted from the original POW documentation files
although the entire  manual has been  reorganized and
expanded.

To print the manual, use POW (what else)!

The file is  formatted  for an 80 column printer with
6 lines  per  inch  spacing  on 8.5 by 11 inch paper.
(Pretty standard stuff.)

* * * * * * * * * * * * * * * * * * * * * * * * * * *
:CE
:DM,10,70
:DB,2,10
:PT,8,4:PB,8,4
:PL,50
:MS,10
:JT
:PG
:PN,0
:LF,10
:CM,"POW"
:LF,2
:CM,Processor Of Words
:LF,2
:CM,USER'S MANUAL
:LF,2
:CM,Version 2.0
:LF,2
:CM,(Feb, 1982)
:NP
:CM,SUMMARY OF REVISIONS
:LF,2
^^The following changes have been made to the version of POW
originally released on CPMUG Volume 36.
:DM,13,67
:DB,2,10
:BP
*##POW will now process input files larger than available memory.
If a file larger than memory is loaded, you will be notified.
Additional portions of the file will be automatically loaded
as needed.
(This feature can be defeated at assembly time if desired.)
:BP
*##POW has a new print option ("C") which permits
continuous printing with fan-fold or roll paper.
The original "P" option for single page printing is still available.
:BP
*##POW has a new view option ("V") which
will display the formatted output on a CRT console.
No more than one screen will be displayed at a time.
(This feature can be defeated at assembly time if desired.)
:BP
*##Eleven new commands
([:CD, [:CE, [:CN, [:CS, [:CU, [:FN, [:FY, [:JR,
[:MD, [:MN and [:MS)
have been added.
See the description in this manual.
:BP
*##The [:CT command will now output the text without the
need for a [:CC command.
As a result, the meaning of the [:CC command has been changed.
See the description in this manual.
:BP
*##A new special character for "quoted space" ([#) has been added.
:BP
*##The ctrl-C function returns to the option menu, unless a file
name is being input.
You must use "Q" from the menu to return to CP/M.
:BP
*##Console input can now be in upper or lower case.
:NP
:DM,10,70
:DB,2,10
:CM,SUMMARY OF REVISIONS
:CM,(continued)
:BP
This User's Manual has been completely revised to reflect
version 2.0 of POW.
The manual is organized so that, if you are a first time user,
you can get a quick overview of POW, followed by details of the
special characters and commands.
:BP
The commands are grouped by function.
Within each group, they are in the approximate order that
you will probably need them.
They could have been arranged in alphabetical order, but
that could be more confusing.
:BP
Once you have read the manual, the summary at the end should
be a good memory jog for the command syntax.
The summary is alphabetized.
:BP
If you used an earlier version of POW, you will notice that
much of the information in this manual differs from the
original documentation.
Some differences are due to program changes and additions.
But many others are just a statement of fact learned
through experience.
:BP
Version 2.0 should work with older POW source files,
except for the [:CT and [:CC commands.
:PN,0
:MS,1
:BM,39,-:-
:TM,10,POW USER'S MANUAL                               INTRODUCTION
:NP
:CM,^^I.  INTRODUCTION\
:DM,10,70
:DB,2,10
:BP
^^POW\ IS A PROGRAM THAT IS A "^PROCESSOR ^OF ^WORDS"
FOR 8080 AND ^Z80 COMPUTERS RUNNING UNDER ^^CP/M\.
^^POW\ IS AVAILABLE FROM THE ^^CP/M\ ^USERS ^GROUP.
:BP
^^POW\ HAS THE ABILITY TO SET MARGINS, TABS,
SPACING, JUSTIFICATION AND INDENTATION.
^IN ADDITION, ^^POW\
PROVIDES AUTOMATIC CENTERING, AND AUTOMATIC PAGING WITH TITLES
AND NUMBERING.
:BP
^THIS PROGRAM WORKS ON AN EXISTING ^^ASCII\ FILE THAT HAS BEEN
PREPARED WITH AN EDITOR (^^ED\ FOR EXAMPLE).
^^Thus, POW is more properly called a "text formatter".
:BP
^COMMANDS ARE FREELY INSERTED INTO THE SOURCE
TEXT WHEN IT IS PREPARED.
^^POW\ WILL REACT TO
THOSE COMMANDS WHEN IT ENCOUNTERS THEM WHILE
PRINTING OUT THE FILE. 
^COMMANDS ALL CONSIST OF THE SAME FORMAT WHICH IS
A "COMMAND IDENTIFIER" IMMEDIATELY FOLLOWED BY A TWO LETTER
COMMAND NAME, THEN A DELIMITER WITH OPTIONAL DATA
FOR THE COMMAND, AND/OR A TERMINATOR. 
^DELIMITERS ARE EITHER A COMMA OR A SPACE, AND A TERMINATOR
CAN BE EITHER A COMMA, A SPACE, OR NOTHING. 
^THIS ALLOWS MAXIMUM FREEDOM FROM RIGID COMMAND SYNTAX.
^A SAMPLE OF THE COMMAND FORMAT IS SHOWN BY THE DEFINITION
OF MARGINS[:
:LF,1
:CM,:^^DM\,10,70
:BP
^IN ADDITION TO THE LIST OF COMMANDS, ^^POW\ ALSO
HAS THE ABILITY TO ALLOW THE USE OF AN UPPER AND LOWER
CASE PRINTER WITH AN UPPER CASE ONLY INPUT FILE.
^THIS IS ACCOMPLISHED BY MEANS OF SPECIAL CHARACTERS,
WHICH CONTROL THE CASE OF THE PRINTED OUTPUT.
:TM,10,POW USER'S MANUAL                               USER'S GUIDE
:NP
:CM,^^II. "POW" USER'S GUIDE\
:DM,13,67
:DB,2,10
:BP
^^1)#Prepare your source file using a standard text editor,
such as CP/M's ED.
This file can contain any of the commands and special characters
defined in this manual.
:BP
2)#Run POW. When prompted, load the source file (the "L" option).
:BP
3)#If the "V" option is available, use it to preview the output.
Corrections can be made to the source file and the results
reexamined using "V" without having to print the file at all.
:BP
4)#Use the "P" or "C" option to print the file.
"P" will pause after each page is printed.
"C" will print the entire file before pausing.
If printing is in error, ctrl-C will stop POW and return to
the option menu.
You can then restart the printer ("P" or "C"), load a different
file ("L"), or quit ("Q").
:BP
5)#A suggestion for users with continuous forms printers.
Use "P" to test the allignment of the first page or two.
Then, if everything is OK, enter ctrl-C to abort the "P" option
and enter "C" to print the entire document.
:BP
6)#Note that POW has several default settings which can be used
without explicitly defining them.
You should be aware, however, that POW does not reset these defaults
each time the option menu is displayed.
Thus, if two files are to be printed, the state of POW may
not be the default state when the second file is loaded.
If a file does not print properly, abort the print (ctrl-C)
and return to CP/M ("Q").
Then, restart POW and try again.
To avoid these problems, it is recommended that format commands
be explicitly defined at the start of each file.
:BP
7)#Remember, ctrl-C will return to the option menu.
You must use the "Q" option to return to CP/M.
:TM,10,POW USER'S MANUAL                         SPECIAL CHARACTERS
:NP
:CM,^^III.  "POW"  SPECIAL CHARACTERS\
:DM,10,70
:DB,2,10
:BP
^^The following special characters are used by POW[:
:JE
:LF,1
         [:      (colon)            command identifier
         [[      (square left)      quote next
         [#      (pound sign)       quoted space
         [^      (caret/up-arrow)   upshift
         [\      (backslash)        downshift
:JT
:BP
A "command identifier" ([:) must preceed a valid POW command string.
If POW recognizes the command, the command is decoded and executed.
If the characters following the "command identifier" are not recognized
as a command, then the entire string is printed.
:BP
A "quoted space" ([#) may be inserted wherever a space is desired
in the text.
This special character is used at a location where the line
should not be broken by filling, and where extra spaces should not
be inserted or deleted during justification.
On output, the "quoted space" is converted to a standard ASCII space.
:BP
A "quote next" ([[)\
PRECEDING A CHARACTER CAUSES THAT CHARACTER TO BE
PRINTED AS IT APPEARS WITH NO DECODING.
^THIS IS USED
TO PRINT ANY SPECIAL CHARACTER.
^FOR EXAMPLE, A BACKSLASH
IS NORMALLY USED TO INDICATE A DOWNSHIFT
AND THUS IS NOT PRINTED. ^SO, [[[\ WOULD CAUSE
THE PRINTING OF THE BACKSLASH.
^^Since [[ is itself a special character, [[[[ must be used
to print it.
:BP
^^The "upshift" ([^) and "downshift" ([\) characters are used
to control the case of the output when the text must be prepared
in upper case only.
:DM,13,67
:DB,1,10
:BP
A)#If one "upshift" is used, the character immediately after it
is printed in upper case.  All following characters are lower case.
:BP
B)#If two "upshifts" are used, this has the effect of an upshift
lock.  All characters following are printed in upper case until
the "downshift" is encountered.
:DM,10,70
:DB,2,10
:NP
The "upshift" and "downshift"
controls are provided so that upper and lower case printing
can be achieved from a text file developed on an upper case only
terminal.
The shift controls only operate on upper case alphabetics.
There is no effect on lower case alphabetics or on non-alphabetic
characters.
:BP
:JE
The following shows the use of the case control characters:

[^HERE IS A [^SAMPLE WITH [^[^UPPER CASE[\ AND LOWER CASE.

becomes the following[:\

^HERE IS A ^SAMPLE WITH ^^UPPER CASE\ AND LOWER CASE.
:JT
:BP
^^The initial state of POW is upshift lock.
Thus, if you prepare your input using a terminal with both upper and
lower case capability, you can use your terminal to control the
case of the output.
Remember to use "quote next" in front of any "upshift" or
"downshift" characters if they appear in your text.
Otherwise, they will alter the case settings.\
:TM,10,POW USER'S MANUAL                                   COMMANDS
:NP
:CM,^^IV.  "POW" COMMANDS\
:BP
^^POW\ COMMANDS CONSIST OF A COLON ([:) FOLLOWED BY A TWO-CHARACTER
ABBREVIATION.
^^The abbreviation MUST BE IN UPPER CASE.\
^THIS SECTION DESCRIBES ALL OF THE ^^POW\ COMMANDS.
^WHEN APPROPRIATE, THE DEFAULT VALUES FOR EACH COMMAND ARE GIVEN.
:LF,1
^^The commands are divided into four groups.
:DM,13,67
:DB,2,10
:BP
A) Page Format Control ...
:LF,1
those commands which define the basic physical layout of the
printed page.
These items include left and right margins, top and bottom messages,
and text length per page.
Defaults are provided for most of these commands.
:BP
B) Text Format Control ...
:LF,1
those commands which define the basic appearance of the text on
the printed page.
These items include justification mode, paragraph break
parameters, spacing, page numbering and tab settings.
Defaults are provided for most of these commands.
:BP
C) Text Output Control ...
:LF,1
individual commands for detailed manipulation of the text.
These include text centering, paragraph breaks, extra line feeds,
forcing of a new page, etc.
No defaults are provided for any of these commands.
:BP
D) Printer Control ...
:LF,1
special commands to doublestrike and underline selected portions
of the text.
:NP
:DM,10,70
:DB,2,10
^^A.  PAGE FORMAT CONTROL
:BP
:CM,^^:DM\,LEFT,RIGHT
:CM,^^(:DM,10,70)\
:BP,^DEFINE ^MARGINS. ^THE ARGUMENTS ARE THE COLUMN LOCATIONS
OF THE "LEFT" AND "RIGHT" MARGINS.
^DEFAULT IS 10,70.
^^When this command is issued, the left margin will be used to
reset the [:DB command also.
See [:DB for more information.\
:BP
:CM,^^:PL\,LINES
:CM,^^(:PL,46)\
:BP
^PAGE ^LENGTH. ^DEFINE THE PAGE LENGTH
(THE TEXT PORTION) TO BE "LINES" LONG.
^DEFAULT IS 46.
:BP
:CM,^^:PT\,LINES,HEADER-LINE
:CM,^^(:PT,10,0)\
:BP
^PAGE ^TOP.
^DEFINE THE PAGE TOP TO CONTAIN "LINES"
BLANK LINES, WITH THE HEADER MESSAGE ON  "HEADER-LINE".
^IF "HEADER-LINE" IS ZERO, THEN NO HEADER IS PRINTED. 
^NOTE THAT "LINES" CAN ALSO BE ZERO FOR A COMPLETELY FILLED PAGE.
^DEFAULT VALUES ARE[: "LINES" = 10; "HEADER-LINE" = 0
:BP
:CM,^^:PB\,LINES,TRAILER-LINE
:CM,^^(:PB,10,0)\
:BP
^PAGE ^BOTTOM.
^DEFINE THE PAGE BOTTOM. ^SEE [:^^PT\ ABOVE.
:BP
^^Note that the "lines" specified in the [:PL, [:PT and [:PB
commands should add up to the length of your printed page.
This is normally 66 lines for standard 8.5 by 11 inch paper
with 6 lines per inch printing.
Any form length can be specified, up to a maximum of 255 lines.\
:NP
:CM,^^:TM\,POS,HEADER-MESSAGE
:BP
^TOP ^MESSAGE.
^DEFINE THE TOP OF PAGE MESSAGE (IE. THE HEADER). ^IT WILL
BE PRINTED AT "POS" AND "HEADER-MESSAGE" WILL BE THE MESSAGE.
^IF PAGE NUMBERING IS DESIRED IN "HEADER-MESSAGE", A COLON
([:) IN THE MESSAGE WILL BE REPLACED BY THE CURRENT PAGE NUMBER.
^^The message must be terminated with a carriage return.\
:LF,1
^EXAMPLE[: "[:^^TM,45,PAGE\-[:-" WOULD CAUSE THE TOP MESSAGE
TO BE PRINTED 45 SPACES FROM THE LEFT OF THE PAGE
(NOT THE LEFT MARGIN) AS "^^PAGE-4-"\ WHEN PAGE 4 IS PRINTED.
:BP
:CM,^^:BM\,POS,TRAILER-MESSAGE
:BP
^BOTTOM ^MESSAGE.
^DEFINES THE BOTTOM OF PAGE MESSAGE. ^SEE [:^^TM\ ABOVE.
:BP
:CM,^^:MS\,NUMBER
:CM,^^(:MS,2)\
:BP
^^Message Start.
Define the page number where top and bottom messages will
start to print.
Default is page 2.
See the [:TM and [:BM commands.
:BP
:CM,^^:FY\
:BP
^^Form Feed Yes.
Enable the form feed option.
Once set, POW will output a form feed at the end of each
page of the text.
This will be automatic, and the [:FY command only needs to be
issued once.
:BP
:CM,^^:FN\
:BP
^^Form Feed No.
Disable the form feed option.
Once disabled, POW will use line feeds to space to the end
of a page.
This is the default status for page endings.
:NP
^^B.  TEXT FORMAT CONTROL\
:BP
:CM,^^:JL\
:BP
^JUSTIFICATION ^LEFT.
^BEGIN LEFT ONLY JUSTIFICATION (RAGGED RIGHT MARGIN)
WITH AUTOMATIC FILLING.
:BP
:CM,^^:JR\
:BP
^JUSTIFICATION ^RIGHT.
^BEGIN RIGHT ONLY JUSTIFICATION (RAGGED LEFT MARGIN)
WITH AUTOMATIC FILLING.
:BP
:CM,^^:JT\
:BP
^JUSTIFICATION ^TOTAL.
^BEGIN TOTAL JUSTIFICATION (LEFT AND RIGHT) 
WITH AUTOMATIC FILLING.
:BP
:CM,^^:JE\
:BP
^JUSTIFICATION ^END.
^CLOSE PRESENT LINE AND END ALL JUSTIFICATION.
^ANY TEXT ENTERED AFTER THIS COMMAND WILL BE REPRODUCED
AS ENTERED, WITH NO FILL OR JUSTIFICATION.
^^This is the default status for justification.\
:BP
:CM,^^:DB\,LINES,COLUMN
:CM,^^(:DB,1,10)\
:BP
^DEFINE ^BREAK.
^DEFINE THE PARAGRAPH BREAK TO BE "LINES" LINE FEED'S
AND THE STARTING POSITION OF THE FIRST LINE IN THE PARAGRAPH
TO BE IN COLUMN "COLUMN".
^THE STARTING COLUMN CAN BE SET AT ANY
POSITION EITHER TO THE RIGHT OR LEFT OF THE LEFT MARGIN.
^DEFAULT VALUES ARE[: "LINES" = 1; "COLUMN" = 10.
^^Note that the starting "column" will be reset to the left
margin if a [:DM command is issued.
Thus, you should reissue a [:DB after a [:DM if you want
a different paragraph starting location.\
:NP
:CM,^^:PN\,NUMBER
:CM,^^(:PN,0)\
:BP
^PAGE ^NUMBER.
^SET THE PAGE NUMBER TO THE SPECIFIED VALUE (MAXIMUM
IS 255). ^DEFAULT IS 0.
:BP
:CM,^^:SP\,SPACING
:CM,^^(:SP,1)\
:BP
^SPACING.
^SET THE SPACING TO THE VALUE SPECIFIED.
^FOR EXAMPLE, 1 = SINGLE SPACE, 2 = DOUBLE SPACE,
ETC. ^DEFAULT IS 1 OR SINGLE SPACING.
:BP
:CM,:^^DT\,T1,T2,T3,...
:CM,^^(:DT,15,22,30,45)
:BP
^DEFINE ^TABS.
^TAB STOPS ARE DEFINED FOR A MAXIMUM OF 14 TABS.
^TAB STOPS ARE ENTERED BY COLUMN NUMBER AND MUST BE IN
ASCENDING ORDER. ^NO ERROR CHECKING IS DONE ON THEM.
^THE PRESENCE OF A TAB CHARACTER IN THE SOURCE FILE WILL BE
CONVERTED TO THE APPROPRIATE NUMBER OF BLANKS TO POSITION
THE NEXT CHARACTER AT THE NEXT AVAILABLE TAB LOCATION.
^DEFAULT LOCATIONS ARE 15, 22, 30 AND 45 COLUMNS FROM THE
LEFT OF THE PAGE.
:NP
^^C.  TEXT OUTPUT CONTROL\
:BP
:CM,^^:CT\,POSITION,TEXT
:BP,^CENTER ^TAB ^TEXT.
^THE "TEXT" IS CENTERED ABOUT THE "POSITION" (COUNTING FROM THE LEFT
OF THE PAGE, NOT THE MARGIN) THAT IS SPECIFIED.
^^Commands are not recognized within the "text" string, nor are
any special characters.
The only exceptions are the "upshift" and "downshift" characters
for case control.\
^THE "TEXT" MUST BE TERMINATED WITH A CARRIAGE RETURN.
:BP
:CM,^^:CM\,TEXT
:BP
^CENTER ^MARGIN ^TEXT.
^AUTOMATICALLY CENTERS THE "TEXT" BETWEEN THE LEFT
MARGIN AND RIGHT MARGIN.
^^Commands are not recognized within the "text" string, nor are
any special characters.
The only exceptions are the "upshift" and "downshift" characters
for case control.\
^THE TEXT MUST BE TERMINATED WITH A CARRIAGE RETURN.
:BP
:CM,:^^CC\
:BP,^COPY ^CENTER.
^THIS COMMAND WILL REPRODUCE THE LAST LINE CENTERED
WITH EITHER A ^^[:CT\ OR ^^[:CM\ COMMAND.
:BP
:CM,^^:LF\,LINES
:BP,^LINE ^FEED.
^THE PAGE IS SPACED UP "LINES" TIMES. ^THIS IS ACTUALLY A
^^CR-LF\ SEQUENCE TO THE PRINTER "LINES" TIMES.
:BP
:CM,^^:BP\
:BP,^BREAK ^PARAGRAPH. ^SINCE CARRIAGE RETURNS ARE
CONVERTED TO SPACES DURING
LEFT, RIGHT OR TOTAL
JUSTIFICATION, IT IS NECESSARY TO BE ABLE TO SPECIFY THE
BEGINNING OF A NEW PARAGRAPH WHILE IN THESE MODES. ^THIS IS
DONE WITH THE [:^^BP\ COMMAND.
^THE PROGRAM CLOSES THE PRESENT LINE,
THEN DOES THE SPECIFIED NUMBER OF LINE FEEDS, AND THEN 
INDENTS TO THE SPECIFIED POSITION.
(^SEE COMMAND [:^^DB\.)
:BP
:CM,^^:NP\
:BP,^NEW ^PAGE. ^FORCES THE CLOSE OF THE PRESENT PAGE, FEEDS
IT OUT OF THE PRINTER, AND THEN BEGINS A NEW PAGE.
:BP
:CM,^^:PG\
:BP,^PAGE. ^IMMEDIATELY FORCES THE BEGINNING OF A NEW PAGE (IT WILL
NOT FINISH THE PRESENT PAGE). ^THIS COMMAND SHOULD ALWAYS BE
GIVEN AT THE BEGINNING OF A NEW TEXT FILE.
^^(It should probably not be used within the text.
Use the [:NP command to break pages within the body of the text.)
:BP :CM,^^:OF\
:BP,^OFF. ^THIS COMMAND "TURNS OFF THE PRINTER".
^THE PROGRAM CONTINUES TO
PROCESS TEXT AND COMMANDS,
BUT THERE IS NO OUTPUT TO THE PRINTER.
:BP,:CM,^^:ON\
:BP,^ON. ^THIS COMMAND WILL "TURN ON THE PRINTER" AGAIN AFTER
IT WAS TURNED OFF BY THE [:^^OF\ COMMAND.
^THAT IS, OUTPUT IS SENT TO THE PRINTER AGAIN.
:BP
:CM,^^:CS\
:BP
^^Comment Start.
Disables all output, all command processing, and all text processing.
Everything that follows this command is ignored by POW with one
exception, and that is the [:CE command.
:BP
:CM,^^:CE\
:BP
^^Comment End.
Restores all output and all text processing functions after
a [:CS command.
:NP
The [:OF and [:ON commands are useful if you need to reprint
a section of a fairly long document.
Just "turn off the printer" for the parts you don't need to
reprint, and "turn it back on" for the parts you do.
Then, when POW processes the file, all of the commands and case
settings will be tracked properly right up to the part you
want to print.
Page numbers, titles, and format will all be correct.
:BP
The [:CS and [:CE commands work entirely different.
These commands are intended to be used to add comments
within the text file.
They can also be used to retain text for use at a future time
without printing it now.
Unlike the [:OF and [:ON commands, the state of POW
remains unchanged during a [:CS-[:CE comment block.
:NP
D.  PRINTER CONTROL
:BP
The following printer commands are used to give emphasis to certain
blocks of text and to text headings.
These commands permit a doublestrike (multiple overprint) for all
portions of the text, or for centered messages only.
Underlining is also provided, but only for centered messages.
These commands are implemented in as general a manner as possible.
However, they may not work with some printers.
They are also bypassed in the "V" (VIEW) mode.
:BP
:CM,^^:MD\,TIMES
:BP
^^Master Doublestrike.
This command will cause all text to be overprinted "times" times.
For example, if "times" = 1, each line is overprinted once, for a
total of two impressions.
This command can be used to emphasize a block of text, or it can be
used to doublestrike an entire document for a darker image.
If [:CD is in effect, the value of "times" is added to the current
Center Doublestrike counter to preserve emphasis of centered text.
The value of "times" is limited to the range 0 - 10.
:BP
:CM,^^:CD\,TIMES
:BP
^^Center Doublestrike.
Similar to the [:MD command, but the overprint is specific to
centered messages.
(That is, output generated from [:CT, [:CM and [:CC commands.)
If [:MD is in effect, the center doublestrike counter will be
the sum of the value specified in "times" and the current value
of the Master Doublestrike.
This feature preserves center message emphasis.
The value of "times" is limited to the range 0 - 10.
:BP
:CM,^^:CU\
:BP
^^Center Underline.
Begin automatic underlining of any centered
text from a [:CT, [:CM, or [:CC command.
:NP
:CM,^^:MN\
:BP
^^Master Normal.
This command clears the master doublestrike and reduces the
center doublestrike to the value entered on the last [:CD command
(if any).
Thus, center message emphasis is preserved if it is in effect.
Note that the command [:MD,0 has the same effect as the [:MN command.
:BP
:CM,^^:CN\
:BP
^^Center Normal.
This command resets the center doublestrike to the current value
of the master doublestrike.
It also clears the center underline if it was in effect.
This clears any special emphasis of centered text.
Note that the command [:CD,0 will clear the center doublestrike
just like the [:CN command.
However, [:CN is the only way to clear center underlining.
:TM,10,POW USER'S MANUAL                                    SUMMARY
:NP
:CM,^^V.  SUMMARY OF COMMANDS AND SPECIAL CHARACTERS\
:BP
:CM,^^SPECIAL CHARACTERS
:JE
:LF,1
         [:      (colon)            command identifier
         [[      (square left)      quote next
         [#      (pound sign)       quoted space
         [^      (caret/up-arrow)   upshift
         [\      (backslash)        downshift
:JT
:BP
:CM,^^COMMANDS
:JE

Format[:               Description[:          Default[:

[:BM,pos,bot-message   Bottom Message
[:BP                   Break Paragraph
[:CC                   Copy Center
[:CD,times             Center Doublestrike
[:CE                   Comment End           [:CE
[:CM,text              Center Margin
[:CN                   Center Normal         [:CN
[:CS                   Comment Start
[:CT,position,text     Center Text
[:CU                   Center Underline
[:DB,lines,column      Define Break          [:DB,1,10
[:DM,left,right        Define Margins        [:DM,10,70
[:DT,t1,t2,t3,...      Define Tabs           [:DT,15,22,30,45
[:FN                   Form-feeds No         [:FN
[:FY                   Form-feeds Yes
[:JE                   Justification End     [:JE
[:JL                   Justification Left
[:JR                   Justification Right
[:JT                   Justification Total
[:LF,lines             Line Feed
[:MD,times             Master Doublestrike
[:MN                   Master Normal         [:MN
[:MS,page-number       Message Start         [:MS,2
[:NP                   New Page
[:OF                   Printer Off
[:ON                   Printer On            [:ON
[:PB,lines,msg-line    Page Bottom           [:PB,10,0
[:PG                   Page
[:PL,lines             Page Length           [:PL,46
[:PN,number            Page Number           [:PN,0
[:PT,lines,msg-line    Page Top              [:PT,10,0
[:SP,spacing           Spacing               [:SP,1
[:TM,pos,top-message   Top Message
